﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Xml.Linq;
using Ninject.MVC.Models;

namespace Ninject.MVC
{
  public class WeatherDataRepository : IWeatherDataRepository
  {
    private readonly string _xmlFile;

    public WeatherDataRepository(string xmlFile)
    {
      _xmlFile = xmlFile;
    }

    public IList<WeatherDataModel> Data(string city)
    {
      var weatherData = !string.IsNullOrEmpty(city)
        ? XElement.Load(_xmlFile).Elements("weather").Where(e => e.Element("city").Value.Equals(city, StringComparison.OrdinalIgnoreCase))
        : XElement.Load(_xmlFile).Elements("weather");

      return weatherData.Select(e => new WeatherDataModel { City = e.Element("city").Value, Temperature = Convert.ToDouble(e.Element("temp").Value) }).ToList();
    }
  }
}